#include <windows.h>
#include <mmsystem.h>

// This source file contains functions for using windows
// multimediatimers. It sets up a callback function
// that increments a integer variable specified every 33
// millisecond.

int *IncrementVar;

UINT TimeID;


void CALLBACK TimeCallback(UINT uID, UINT uMsg, DWORD
	dwUser, DWORD dw1, DWORD dw2)
{
	(*IncrementVar)++;
}

// Returns TRUE if successful and FALSE if failure
int StartCounter(int *IncVar)
{
	if (timeBeginPeriod(1) == TIMERR_NOCANDO)
		return FALSE;

	IncrementVar = IncVar;

	if ((TimeID = timeSetEvent(17,1,TimeCallback,0,TIME_PERIODIC)) 
		== (unsigned int)NULL) return FALSE;
	
	return TRUE;
}


void StopCounter(void)
{
	timeKillEvent(TimeID);
	timeEndPeriod(1);
}

 