
// Character and string drawing functions.
// There is functions for drawing characters
// in a grid and anywhere on the screen.

#define _FXCHARACTER_

#ifndef _FXENGINE_
#include "fxenginedrv.h"
#endif

fxeTextureHandle DefaultStrTexture;

void fxeStrSetGridDimensions(int Width, int Height);

void fxeStrDefaultProperties(void);

void fxeStrSetColor(float r, float g, float b);

void fxeStrSetOpacity(unsigned char Opacity);

void fxeStrSetTexture(fxeTextureHandle CharSetTex);

void fxeStrDrawGrid(int GridX, int GridY, char *String);

void fxeStrDrawXY(int x, int y, char *String);

void fxeCharDrawGrid(int x, int y, char Character);

void fxeCharDrawXY(int x, int y, char Character);